#include <FCNTL.H>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <dos.h>

#include "nameh.h"

int NamedTiles=0;

void FindTileName (Telement *element, int tilenum, char ** S) {
int i;
	for (i=0; i < NamedTiles; i++)
		if (element [i].tilenumber == tilenum) {
			*S = element [i].name;
			break;
		}
	if (i >= NamedTiles) *S = "";
}

Telement * LoadNameH (void) {
int handle, i=0;
char ch;
char sfile [30000]; unsigned int b_read;
char *p;
Telement *element;

	handle = open ("names.h", O_RDONLY+O_TEXT);
	if (handle <= 0) {
		printf ("Can't find file NAMES.H");
		exit (3);
	}


	while (!eof (handle)) {  // Throws out first line
		read (handle, &ch, 1);
		if (ch=='\n') {break;}
	}
	// First, find how many elements there are
	while (!eof (handle)) {   // Read whole file into mem for working with
		// Loop in case file is BIGGER than 30000
		b_read = read (handle, sfile, 30000);
		for (i=0; i <= b_read; i++)
			if (sfile [i] == '\n'){
				NamedTiles ++;
				sfile[i] = ' ';  // Convert lfs to space for parsing.
			}
	}
	close (handle);
	sfile [b_read + 1]='\0';  // Important null on the end for strtok to stop.
	i=0;                      // Reset counter after reading file
	NamedTiles--;   // First line is a comment, not an item;
	element = malloc (sizeof (Telement) * NamedTiles);

	p = strtok (sfile, " ");  // First token search
	while (!!(p = strtok (NULL, " "))) {// Looking for tokens delimd by ' '
		switch (p [0]) {
			case '#': //printf ("%s\t",p);
				break; // The word #define is not needed.
			case '1':; case '2':; case '3':; case '4':; case '5':; case '6':;
			case '7':; case '8':; case '9':; case '0':
				// The tile number was found in the file - tidy up this element
				// and move on to the next.
				element [i].tilenumber = atoi (p);
//				printf ("Number %3d   Name: %-20s   Tile Number: %4d\n", i, element [i].name,
//					element [i].tilenumber);
				i++;
				break;
			default:
				// With a letter token, allocates space for the name and names.
				if (!(element [i].name = malloc (strlen (p))))
					printf ("Out of memory on element %d", i);
				strcpy (element [i].name, p);
		}

	}
	//free (sfile);
	return element;
}

void FreeNamedTiles (Telement *element) {
	for (;NamedTiles >= 0; NamedTiles --) {
		free (element [NamedTiles - 1].name);
	}
	free (element);
}